<?php
namespace Utils;
use Config\Config;

/**
 * 工具类
 * Class encryptUtil
 */
class EncryptUtil
{
    /**
     * Aes加密
     * @param $str
     * @param $key
     * @param $iv
     * @return string
     * @throws \Exception
     */
    public static function encrypt($str,$key,$iv)
    {
        $sign = openssl_encrypt($str, 'AES-256-CFB', $key, OPENSSL_RAW_DATA, $iv);
        return bin2hex($sign);
    }

    /**
     * @param $str
     * @param $key
     * @param $iv
     * @return string
     */
    public static function decrypt($str, $key, $iv)
    {
        $decrypt = openssl_decrypt(hex2bin($str), 'AES-128-CBC', $key, OPENSSL_RAW_DATA | OPENSSL_ZERO_PADDING, $iv);
        return rtrim($decrypt, "\0");
    }

    /**
     * @param int $length
     * @return string
     * @throws \Exception
     */
    public static function random($length = 16)
    {
        $string = '';

        while (($len = strlen($string)) < $length) {
            $size = $length - $len;

            $bytes = random_bytes($size);

            $string .= substr(str_replace(['/', '+', '='], '', base64_encode($bytes)), 0, $size);
        }

        return $string;
    }
}
