<?php
namespace Utils;
use Config\Config;


/**
 * 工具类
 * Class SignUtil
 */
class SignUtil
{
    /**
     * 计算签名
     * @param $params
     * @return string
     */
    public static function calSign($params)
    {
        $names = array_keys($params);
        sort($names, SORT_STRING);

        $item_array = array();
        foreach ($names as $name) {
            $item_array[] = "{$name}={$params[$name]}";
        }

        $str = implode('&', $item_array) . '&key=' . Config::APP_SECRET;
        return strtoupper(md5($str));
    }

    /**
     *验证签名
     * @param $params
     * @return array
     */
    public static function verifyRequest($params) {
        $signature = $params['signature'];
        unset($params['signature']);

        $calSign = self::calSign($params);

        /** 验证签名 */
        if ($calSign == $signature) {
            $interval = time() - $params['timestamp'];

            /** 检查时间戳 */
            if ($interval >= 0 && $interval < 10) {
                $result = ['errcode' => 0, 'errmsg' => 'ok'];
            } else {
                //可能是重放攻击
                $result = ['errcode' => 5003, 'errmsg' => '请求接口失败'];
            }
        } else {
            //签名错误
            $result = ['errcode' => 5004, 'errmsg' => '签名错误'];
        }

        return $result;
    }
}
